
 #ifndef _KB_CPP
 #define _KB_CPP

 TKB::TKB()
 {
 }

 TKB::~TKB()
 {
 }

 void TKB::Init(TMEM *MEMIn)
 {
    MEM=MEMIn;
    //    (CapsLock=OFF)
    asm {
       push    es
       push    ax
       mov		ax,0x0000
       mov		es,ax
       mov     al,es:0x0417
       and     al,0xBF
       mov		es:0x0417,al
       pop     ax
       pop     es
    }
    Register=LAT;
    REGKey=0;
    UPRKey=0;
    StrobeStatus=1;
 }

 void TKB::Strobe()
 {
    StrobeStatus=1;
    //  7=0 -   
    for(TWord index=0xC000; index<=0xC00F; index++)
       MEM->Cell[index]=MEM->Cell[index]&0x7F;
 }

 void TKB::GetKey()
 {
    //     , 
    if(!StrobeStatus)
       return;

    /*     */
    int key=0;
    while(!key)
       key=getch();
    //    
    //    
    if(key>=128)
       MEM->Cell[0xC063]=0x80;
    else
       MEM->Cell[0xC063]=0x00;
    for(TWord i=0xC000; i<=0xC00F; i++)
       MEM->Cell[i]=0x7F&key;
    return;

    TByte KeyboardStatusByte1;
    TWord BufferBegin, //  
          BufferEnd;   //  
    union
    {
       struct
       {
          TByte ASCII,
                ScanCode;
       };
       TWord Word;
    } BufferWord;  // 
    TByte ResultCode;

    asm {
       push    es
       push    ax
       mov     ax,0x0000
       mov     es,ax
       mov     ax,es:0x041A
       mov     BufferBegin,ax
       mov     ax,es:0x041C
       mov     BufferEnd,ax
       pop     ax
       pop     es
    }
    //   , 
    //if(BufferBegin==BufferEnd)
    //   return;

    /*  ,    ,
            ,
           
    */
    //  
    StrobeStatus=0;
    //     
    asm {
       push    es
       push    ax
       mov		ax,0x0000
       mov		es,ax
       mov		bx,0x0418
       mov     al,es:[bx]
       mov	   KeyboardStatusByte1,al
       pop     ax
       pop     es
    }
    //   
    // CapsLock=0 - LAT
    // CapsLock=1 - RUS
    if(((KeyboardStatusByte1)<<1)>>7)
       Register=RUS;
    else
       Register=LAT;
    //     ( PC - Shift)
    REGKey=((((KeyboardStatusByte1)<<6)>>7) ||
            (((KeyboardStatusByte1)<<7)>>7)  );
    //     ( PC - Ctrl)
    UPRKey=(((KeyboardStatusByte1)<<5)>>7);

    //    
    asm {
       push    es
       push    ax
       push    bx
       mov     ax,0x0000
       mov     es,ax
       mov     bx,BufferBegin
       mov     ax,es:[bx]
       mov     BufferWord,ax
       //  
       mov     ax,0x041E
       mov     bx,0x041A
       mov     es:[bx],ax
       mov     bx,0x041C
       mov     es:[bx],ax
       pop     bx
       pop     ax
       pop     es
    }

	 /*     
           ,   .
    */

    //       
    if(Register==RUS && !REGKey && !UPRKey)
    {
    }

    //    
    //    
    //for(TWord i=0xC000; i<=0xC00F; i++)
    //   MEM->Cell[i]=
    static first=1;
    if(first)
    {
       asm {
             //    BIOS
             mov ax,0x003;
             int 0x10;
       }
       first=0;
    }
    printf("\n Register=%c REGKey=%c UPRKey=%c",
               Register+0x30,
                           REGKey+0x30,
                                     UPRKey+0x30);
 }

 void TKB::GetRegister()
 {
 }

 #endif