
 #ifndef _MEM_H
 #define _MEM_H

 class TMEM
 {
    public:
       TMEM();
       ~TMEM();
       void Init(TVS *VSIn, TKB *KBIn);
       TByte Read(TWord address);
       void Write(TWord address, TByte byteIn);
       // 64K  
       TByte *Cell;
    protected:
       /*    */
       //  /
       TWord IOZoneBegin;
       TWord IOZoneEnd;
       //   
       TWord ROMZoneBegin;
       TWord ROMZoneEnd;
       //     
       TVS *VS;
       TKB *KB;
 };

 #endif

