
 #ifndef _CLK_H
 #define _CLK_H

 class TCLK
 {
    public:
       TCLK();
       ~TCLK();
       void Init(TCPU *CPUIn, TMEM *MEMIn, TVS *VSIn);
       void Tick();
       void On();
       void Off();
    protected:
       unsigned long Frequency;
       TCPU *CPU;
       TMEM *MEM;
       TVS *VS;
       unsigned long TickNumber;
       unsigned long Divider;   
 };

 #endif