
 // NewTI v2.0
 // (c)1999-2000 by Sergo

 // NewTI2 - NewTextInterface v2.0
 // -   
 //       DOS

 //       .
 //  -   -  ,     
 //   .

 #include <conio.h>
 #include <dos.h>

 #ifndef NULL
 #include <_null.h>
 #endif

 #define Black        0x0000
 #define DarkGray     0x0800
 #define Blue         0x0100
 #define LightBlue    0x0900
 #define Green        0x0200
 #define LightGreen   0x0A00
 #define Cyan         0x0300
 #define LightCyan    0x0B00
 #define Red          0x0400
 #define Orange       0x0C00
 #define Magenta      0x0500
 #define LightMagenta 0x0D00
 #define Brown        0x0600
 #define Yellow       0x0E00
 #define LightGray    0x0700
 #define White        0x0F00

 #define LEFT 75
 #define RIGHT 77
 #define UP 72
 #define DOWN 80
 #define ESC 27
 #define TAB 9
 #define SPACE 32
 #define ENTER 13
 #define BACKSPACE 8
 #define F1 59
 #define F2 60
 #define F3 61
 #define F10 68

 int _TextAttributes=White|(Black<<4);
 int _XCurrent=0;
 int _YCurrent=0;
 char palettes[2000];

 //  
 void cls()
 {
    asm {
        mov  ax,0xB800
        push ax
        pop  es
        xor  di,di
        mov  ax,_TextAttributes
        mov  cx,25*80
        rep  stosw
        }
 }

 //  
 void InitNewTI()
 {
 asm {
                //    80*25
                mov     ah,0x00
                mov     al,0x03
                int     0x10

 /*               //   
                cld
                mov     di,offset palettes
                //call    read_palette
                mov     dx,0x03C7
                mov     al,0
                out     dx,al
                mov     dl,0xC9
                mov     cx,256*3
                rep     insb
                //
                mov     di,offset palettes+256*3
                //call    read_palette
                mov     dx,0x03C7
                mov     al,0
                out     dx,al
                mov     dl,0xC9
                mov     cx,256*3
                rep     insb
                //
 */               
     }
     _setcursortype(0);
 }

 //   
 int StringLength(char *str)
 {
    int length=0;
    while(str[length])
       length++;
    return length;
 }

 //  
 void StringCopy(char *str1, char *str2)
 {
    int pos=0;
    while(str2[pos])
       str1[pos]=str2[pos++];
    str1[pos]='\0';
 }

 // 㭪  ⭮ 室 
 /*void waitretrace()
 {
    asm {
        mov  dx,0x03DA
        }
 m1:
    asm {
        in   al,dx
        test al,8
        jnz  m1
        }
 m2:
    asm {
        in   al,dx
        test al,8
        jz   m2
        }
 } */

 //   
 inline void SetTC(int color)
 {
    _TextAttributes=(_TextAttributes&0xF000)|color;
 }

 //   
 inline void SetBC(int color)
 {
    _TextAttributes=(_TextAttributes&0x0F00)|(color<<4);
 }

 //  
 inline void xy(int x, int y)
 {
    _XCurrent=x-1;
    _YCurrent=y-1;
 }

 //     
 void qput(int x, int y, int sym)
 {
    sym=sym&0x00FF;
    int Offs=(y-1)*160+(x-1)*2;
    int Value=_TextAttributes|sym;
    //poke(0xB800,offset,value);
    asm {
        push si
        push 0xB800
        pop  es
        mov  si,Offs
        mov  ax,Value
        mov  es:[si],ax
        pop  si
        }
 }

 void print(char *str)
 {
    while(*str)
    {
       if(*str=='\n')
       {
          str++;
          _XCurrent=1;
          _YCurrent++;
          if(_YCurrent>25)
             _YCurrent=1;
          continue;
       }
       qput(_XCurrent+1,_YCurrent+1,*str);
       str++;
       _XCurrent++;
       if(_XCurrent>80)
       {
          _XCurrent=1;
          _YCurrent++;
          if(_YCurrent>25)
             _YCurrent=1;
       }
    }
 }

 //    
 void Center(int y,char *str)
 {
    xy(40-StringLength(str)/2,y);
    print(str);
 }

 //  
 void FillArea(int x1, int y1, int x2, int y2, char sym=' ')
 {
    for(register int row=y1;row<=y2;row++)
       for(register int col=x1;col<=x2;col++)
          qput(col,row,sym);
 }

 class Rect
 {
    public:
       int x1,y1,x2,y2;
       Rect(int xt1,int yt1,int xt2, int yt2)
       {
          x1=xt1;
          y1=yt1;
          x2=xt2;
          y2=yt2;
       }
       virtual ~Rect() {};
 };

 class Frame:public Rect
 {
    public:
       int Color;
       Frame(int x1,int y1,int x2,int y2);
       virtual ~Frame() {};
       virtual void Show();
 };

 Frame::Frame(int x1, int y1, int x2, int y2):
        Rect(x1,y1,x2,y2)
 {
    Color=White;
 }

 void Frame::Show()
 {
    int i;
    SetTC(Color);
    qput(x1,y1,201);
    for(i=x1+1;i<x2;i++)
       qput(i,y1,205);
    qput(i,y1,187);
    for(i=y1+1;i<y2;i++)
    {
       qput(x1,i,186);
       qput(x2,i,186);
    }
    qput(x1,y2,200);
    for(i=x1+1;i<x2;i++)
       qput(i,y2,205);
    qput(i,y2,188);
 }

 #define MaxWin 32
 #define OK     0
 #define Error  1

 class Win:public Rect
 {
    protected:
       void *Buffer;
    public:
       int Present;
       int FrameColor,
           WinColor,
           TextColor,
           TitleColor,
           Length,
           Width;
       char *Title;
       Win(int xt1, int yt1, int xt2, int yt2, char *t);
       virtual ~Win();
       virtual int Show();
       virtual void Hide();
       virtual void Out(int x, int y, char *text);
 };

 Win::Win(int xt1, int yt1, int xt2, int yt2, char *t)
     :Rect(xt1,yt1,xt2,yt2),
     Buffer(NULL),
     Title(NULL)
 {
    Present=0;
    Title=new char [StringLength(t)+1];
    StringCopy(Title,t);
    FrameColor=White;
    WinColor=Blue;
    TextColor=White;
    TitleColor=Yellow;
    Length=x2-x1+1;
    Width=y2-y1+1;
 }

 Win::~Win()
 {
    if(Title)
      delete [] Title;
    if(Buffer)
      delete [] Buffer;
 }

 void Win::Out(int x, int y, char *text)
 {
    if(!Present)
       return;
    window(x1,y1,x2,y2);
    xy(x+x1,y+y1);
    SetTC(TextColor);
    print(text);
    window(1,1,80,25);
 }

 int Win::Show()
 {
    register int i;
    if(Present)
       return Error;
    if(x1<1||x2>79||y1<1||y2>24||x1>=x2||y1>=y2)
       return Error;
    Buffer=new char[2*(Length+1)*(Width+1)];
    if(Buffer==NULL)
       return Error;
    Present=1;
    gettext(x1,y1,x2+1,y2+1,Buffer);
    int XMiddle=Length/2+x1;
    int YMiddle=Width/2+y1;
    int left,right,top,bottom;
    left=right=XMiddle;
    top=bottom=YMiddle;
    left--;
    right++;
    top--;
    bottom++;
    while(left>x1||right<x2||top>y1||bottom<y2)
    {
       if(left>x1)
          left--;
       if(right<x2)
          right++;
       if(top>y1)
          top--;
       if(bottom<y2)
          bottom++;
       SetBC(WinColor);
       //waitretrace();
       FillArea(left,top,right,bottom);
    }
       SetTC(FrameColor);
       qput(left,top,201);
       for(i=left+1;i<right;i++)
          qput(i,top,205);
       qput(i,top,187);
       for(i=top+1;i<bottom;i++)
       {
          qput(left,i,186);
          qput(right,i,186);
       }
       qput(left,bottom,200);
       for(i=left+1;i<right;i++)
          qput(i,bottom,205);
       qput(i,bottom,188);
       for(i=y1+1;i<=y2+1;i++)
       {
          int Offs=(i-1)*160+x2*2;
          asm {
              push si
              push 0xB800
              pop  es
              mov  si,Offs
              mov  ax,es:[si]
              xor  ah,ah
              or   ah,0x01
              mov  es:[si],ax
              pop  si
              }
       }
       for(i=x1+1;i<=x2+1;i++)
       {
          int Offs=y2*160+(i-1)*2;
          asm {
              push si
              push 0xB800
              pop  es
              mov  si,Offs
              mov  ax,es:[si]
              xor  ah,ah
              or   ah,0x01
              mov  es:[si],ax
              pop  si
              }
       }
       if(Title)
       {
          SetTC(TitleColor);
          xy(XMiddle-StringLength(Title)/2,y1);
          print(Title);
       }
       return OK;
 }

 void Win::Hide()
 {
    if(!Present)
       return;
    //waitretrace();
    puttext(x1,y1,x2+1,y2+1,Buffer);
    Present=0;
    if(Buffer)
       delete [] Buffer;
 }

 class OnlyWin: public Win
 {
    public:
    OnlyWin(int xt1, int yt1, int xt2, int yt2, char *t);
    virtual ~OnlyWin() {};
    virtual int Show();
 };

 OnlyWin::OnlyWin(int xt1, int yt1, int xt2, int yt2, char *t):
          Win(xt1,yt1,xt2,yt2,t)
 {
    Present=0;
    Title=new char [StringLength(t)+1];
    StringCopy(Title,t);
    FrameColor=White;
    WinColor=Blue;
    TextColor=White;
    TitleColor=Yellow;
    Length=x2-x1+1;
    Width=y2-y1+1;
 }

 int OnlyWin::Show()
 {
    register int i;
    if(Present)
       return Error;
    Buffer=new char[2*(Length+1)*(Width+1)];
    if(Buffer==NULL)
       return Error;
    Present=1;
    gettext(x1,y1,x2+1,y2+1,Buffer);
    int XMiddle=Length/2+x1;
    int YMiddle=Width/2+y1;
    int left,right,top,bottom;
    left=right=XMiddle;
    top=bottom=YMiddle;
    left--;
    right++;
    top--;
    bottom++;
    while(left>x1||right<x2||top>y1||bottom<y2)
    {
       if(left>x1)
          left--;
       if(right<x2)
          right++;
       if(top>y1)
          top--;
       if(bottom<y2)
          bottom++;
       SetBC(WinColor);
       //waitretrace();
       FillArea(left,top,right,bottom);
    }
       SetTC(FrameColor);
       qput(left,top,201);
       for(i=left+1;i<right;i++)
          qput(i,top,205);
       qput(i,top,187);
       for(i=top+1;i<bottom;i++)
       {
          qput(left,i,186);
          qput(right,i,186);
       }
       qput(left,bottom,200);
       for(i=left+1;i<right;i++)
          qput(i,bottom,205);
       qput(i,bottom,188);
       if(Title)
       {
          SetTC(TitleColor);
          xy(XMiddle-StringLength(Title)/2,y1);
          print(Title);
       }
       return OK;
 }

 #define MaxPoints 12

 struct SelPoint
 {
    int PointNumber;
    int SubPointNumber;
 };

 class Menu: public Rect
 {
    public:
    int ActivePoint;
    int SubActivePoint[MaxPoints];
    int PointAmount;
    int BackgroundColor,
        TextColor,
        ActiveBackgroundColor,
        ActiveTextColor,
        SubBackgroundColor,
        SubTextColor,
        SubActiveBackgroundColor,
        SubActiveTextColor,
        SubFrameColor,
        FirstLetterColor;
    char Point[MaxPoints][20];
    char SubPoint[MaxPoints][MaxPoints][20];
    int SubPointAmount[MaxPoints];
    Menu(int y);
    void Show();
    void Hide();
    struct SelPoint Work();
    void AddPoint(int NumPoint, char *str);
    void AddSubPoint(int NumPoint, int NumSubPoint, char *str);
 };

 Menu::Menu(int y):
       Rect(1,y,80,y)
 {
    PointAmount=0;
    ActivePoint=0;
    for(int i=0;i<MaxPoints;i++)
    {
       Point[i][0]='\0';
       SubPointAmount[i]=0;
       SubActivePoint[i]=0;
       for(int j=0;j<MaxPoints;j++)
          SubPoint[i][j][0]='\0';
    }
    BackgroundColor=LightGray;
    TextColor=Black;
    ActiveBackgroundColor=Black;
    ActiveTextColor=Yellow;
    SubBackgroundColor=LightGray;
    SubTextColor=Black;
    SubActiveBackgroundColor=Black;
    SubActiveTextColor=Yellow;
    SubFrameColor=LightBlue,
    FirstLetterColor=Red;
 }

 void Menu::Show()
 {
    SetBC(BackgroundColor);
    SetTC(TextColor);
    for(int i=1;i<=80;i++)
       qput(i,y1,' ');
    int pos=3;
    for(int i=0;i<PointAmount;i++)
    {
       SetTC(TextColor);
       xy(pos,y1);
       print(Point[i]);
       SetTC(FirstLetterColor);
       qput(pos,y1,Point[i][0]);
       pos+=StringLength(Point[i])+2;
    }
 }

 void Menu::Hide()
 {
 }

 struct SelPoint Menu::Work()
 {

    //****

    struct SelPoint Result;
    int key=0;
    int acpos;
    while(key!=ESC&&key!=TAB&&key!=ENTER)
    {
       SetBC(BackgroundColor);
       for(register int i=1;i<=80;i++)
          qput(i,y1,' ');
       int pos=3;
       for(int i=0; i<PointAmount; i++)
       {
          if(i==ActivePoint)
             acpos=pos;
          xy(pos,y1);
          SetTC(TextColor);
          print(Point[i]);
          SetTC(FirstLetterColor);
          qput(pos,y1,Point[i][0]);
          pos+=StringLength(Point[i])+2;
       }
       SetBC(ActiveBackgroundColor);
       for(int i=acpos-1; i<acpos+StringLength(Point[ActivePoint])+1; i++)
          qput(i,y1,' ');
       xy(acpos,y1);
       SetTC(ActiveTextColor);
       print(Point[ActivePoint]);
       SetTC(FirstLetterColor);
       qput(acpos,y1,Point[ActivePoint][0]);

       key=getch();
       if(key==LEFT&&ActivePoint>0)
       {
          ActivePoint--;
          continue;
       }
       if(key==LEFT)
       {
          ActivePoint=PointAmount-1;
          continue;
       }
       if(key==RIGHT&&ActivePoint<PointAmount-1)
       {
	  ActivePoint++;
          continue;
       }
       if(key==RIGHT)
       {
	  ActivePoint=0;
          continue;
       }
    }
    if(key==ESC)
    {
       Show();
       Result.PointNumber=0;
       Result.SubPointNumber=0;
       return Result;
    }

    if(key==ENTER)
    {
       if(SubPointAmount[ActivePoint]==0)
       {
          Show();
          Result.PointNumber=ActivePoint+1;
          Result.SubPointNumber=0;
          return Result;
       }
       // 饬 ᠬ  㭪 
       int maxlength=0;
       for(int i=0;i<SubPointAmount[ActivePoint];i++)
          if(StringLength(SubPoint[ActivePoint][i])>maxlength)
             maxlength=StringLength(SubPoint[ActivePoint][i]);
       // 塞 ਭ   
       int sublength=maxlength+3;
       int subwidth=SubPointAmount[ActivePoint]+1;
       //  न
       int subx;
       int suby;
       if(sublength+acpos-1<80)
          subx=acpos-1;
       else
          subx=79-sublength;
       suby=y1+1;
       // 㥬 
        int xx1=subx;
       int yy1=suby;
       int xx2=subx+sublength;
       int yy2=suby+subwidth;
       void* Buffer=new char[2*(sublength+1)*(subwidth+1)];
       if(Buffer==NULL)
       {
          Result.PointNumber=-1;
          Result.SubPointNumber=-1;
          return Result;
       }
       gettext(xx1,yy1,xx2+1,yy2+1,Buffer);
       SetBC(SubBackgroundColor);
       //waitretrace();

       FillArea(xx1,yy1,xx2,yy2);
       SetTC(SubFrameColor);
       qput(xx1,yy1,0xDA);
       int i;
       for(i=xx1+1; i<xx2; i++)
          qput(i,yy1,0xC4);
       qput(i,yy1,0xBF);
       for(i=yy1+1;i<yy2;i++)
       {
          qput(xx1,i,0xB3);
          qput(xx2,i,0xB3);
       }
       qput(xx1,yy2,0xC0);
       for(i=xx1+1;i<xx2;i++)
          qput(i,yy2,0xC4);
       qput(i,yy2,0xD9);
       for(i=yy1+1;i<=yy2+1;i++)
       {
          int Offs=(i-1)*160+xx2*2;
          asm {
              push si
              push 0xB800
              pop  es
              mov  si,Offs
              mov  ax,es:[si]
              xor  ah,ah
              or   ah,0x01
              mov  es:[si],ax
              pop  si
              }
       }
       for(i=xx1+1;i<=xx2+1;i++)
       {
          int Offs=yy2*160+(i-1)*2;
          asm {
              push si
              push 0xB800
              pop  es
              mov  si,Offs
              mov  ax,es:[si]
              xor  ah,ah
              or   ah,0x01
              mov  es:[si],ax
              pop  si
              }
       }

       key=0;
       while(key!=ESC&&key!=TAB&&key!=ENTER)
       {
          SetBC(SubBackgroundColor);
          SetTC(SubTextColor);
          for(i=0;i<SubPointAmount[ActivePoint];i++)
          {
             for(int j=subx+1;j<subx+maxlength+3;j++)
                qput(j,suby+i+1,' ');

             xy(subx+2,suby+i+1);
             print(SubPoint[ActivePoint][i]);
             SetTC(FirstLetterColor);
             qput(subx+2,suby+i+1,SubPoint[ActivePoint][i][0]);
             SetTC(SubTextColor);
          }
          SetBC(SubActiveBackgroundColor);
          SetTC(SubActiveTextColor);
          for(i=subx+1;i<subx+maxlength+3;i++)
             qput(i,suby+SubActivePoint[ActivePoint]+1,' ');
          xy(subx+2,suby+SubActivePoint[ActivePoint]+1);
          print(SubPoint[ActivePoint][SubActivePoint[ActivePoint]]);
          SetTC(FirstLetterColor);
          qput(subx+2,suby+SubActivePoint[ActivePoint]+1,SubPoint[ActivePoint][SubActivePoint[ActivePoint]][0]);
          SetTC(SubTextColor);
          key=getch();
          if(key==UP&&SubActivePoint[ActivePoint]>0)
          {
             SubActivePoint[ActivePoint]--;
             continue;
          }
          if(key==UP)
          {
             SubActivePoint[ActivePoint]=SubPointAmount[ActivePoint]-1;
             continue;
          }
          if(key==DOWN&&SubActivePoint[ActivePoint]<SubPointAmount[ActivePoint]-1)
          {
      	    SubActivePoint[ActivePoint]++;
             continue;
          }
          if(key==DOWN)
          {
             SubActivePoint[ActivePoint]=0;
             continue;
          }
       }
       puttext(xx1,yy1,xx2+1,yy2+1,Buffer);
       delete [] Buffer;
       Show();
       if(key==ENTER)
       {
          Result.PointNumber=ActivePoint+1;
          Result.SubPointNumber=SubActivePoint[ActivePoint]+1;
          return Result;
       }
          Result.PointNumber=0;
          Result.SubPointNumber=0;
          return Result;
    }
    return Result; // for no warning message!!!
 }

 void Menu::AddPoint(int NumPoint, char *str)
 {
    if(PointAmount>=MaxPoints)
       return;
    StringCopy(Point[NumPoint-1],str);
    PointAmount++;
 }

 void Menu::AddSubPoint(int NumPoint, int NumSubPoint, char *str)
 {
    StringCopy(SubPoint[NumPoint-1][NumSubPoint-1],str);
    SubPointAmount[NumPoint-1]++;
 }

 class DeskTop: public Rect
 {
    public:
    char FillSymbol;
    int BackgroundColor,
        TextColor;
    DeskTop(int x1, int y1, int x2, int y2);
    virtual ~DeskTop() {};
    virtual void Show();
 };

 DeskTop::DeskTop(int x1, int y1, int x2, int y2):
          Rect(x1,y1,x2,y2)
 {
    FillSymbol=0xB0;
    BackgroundColor=LightGray;
    TextColor=LightBlue;
 }

 void DeskTop::Show()
 {
    SetBC(BackgroundColor);
    cls();
    SetTC(TextColor);
    FillArea(x1,y1,x2,y2,FillSymbol);
 }

 class StatusLine:public Rect
 {
    public:
    int BackgroundColor,
        TextColor;
    char info[80];
    StatusLine(int y);
    void Show();
 };

 StatusLine::StatusLine(int y):
             Rect(1,y,80,y)
 {
    BackgroundColor=LightGray;
    TextColor=Black;
    info[0]='\0';
 }

 void StatusLine::Show()
 {
    SetBC(BackgroundColor);
    for(int i=1;i<=80;i++)
       qput(i,y1,' ');
    SetTC(TextColor);
    Center(y1,info);
 }

 class Button: public Win
 {
    public:
       Button();
       Button(int, int, int, int, char*);
       virtual ~Button();
       virtual int Show();
       char ButtonTitle[40];
 };

 Button::Button()
        :Win(0, 0, 0, 0, "")
 {
 }

 Button::Button(int x1, int y1, int x2, int y2, char* str)
        :Win(x1, y1, x2, y2, "")
 {
    StringCopy(ButtonTitle, str);
 }

 Button::~Button()
 {
    Win::~Win();
 }

 int Button::Show()
 {
    int StartPosition=((x2-x1-StringLength(ButtonTitle))/2)+x1;
    WinColor=Blue;
    Win::Show();
    SetTC(White);
    xy(StartPosition, y1);
    print(ButtonTitle);
    SetTC(Orange);
    qput(StartPosition, y1, ButtonTitle[0]);
    return 0;
 }
