
 #ifndef _TVS_H
 #define _TVS_H

 enum VideoMode {TXT32,
                 TXT64,
                 GR128,
                 GR256Lo,
                 GR256Hi,
                 GR512};
 class TVS
 {
    public:
       TVS();
       ~TVS();
       void Init(TMEM *MEMIn);
       void SetMode(TWord address);
       void SetPalette(TWord address);
       void ShowScreen();
       void ModifyScreen(TWord address);
       TWord VideoZoneBegin;
       TWord VideoZoneEnd;
    protected:
       TMEM *MEM;
       // 
       TWord Mode;
       //  
       TWord PaletteNumber;
       //  
       TWord Color[16];
       TWord BeforePaletteAddress;
       void PutSymbol64(TWord x, TWord y, TByte symbol);
       void PutSymbol32(TWord x, TWord y, TByte symbol, TByte attribute);
       /*   TXT64  TXT32 */
       // TXT64:   10x15
       // TXT32:   20x15 (  X)
       TWord *Font;
 };

 #endif